Package org.eclipse.jgit.lib

## Class MutableObjectId

- java.lang.Object
- - org.eclipse.jgit.lib.AnyObjectId
  - - org.eclipse.jgit.lib.MutableObjectId

All Implemented Interfaces:
  `Comparable<AnyObjectId>`

    public class MutableObjectId
    extends AnyObjectId

A mutable SHA-1 abstraction.

### Constructor Summary

Constructors
`MutableObjectId()` Empty constructor.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `clear()` Make this id match `ObjectId.zeroId()`.
`void` `fromObjectId​(AnyObjectId src)` Copy an ObjectId into this mutable buffer.
`void` `fromRaw​(byte[] bs)` Convert an ObjectId from raw binary representation.
`void` `fromRaw​(byte[] bs, int p)` Convert an ObjectId from raw binary representation.
`void` `fromRaw​(int[] ints)` Convert an ObjectId from binary representation expressed in integers.
`void` `fromRaw​(int[] ints, int p)` Convert an ObjectId from binary representation expressed in integers.
`void` `fromString​(byte[] buf, int offset)` Convert an ObjectId from hex characters (US-ASCII).
`void` `fromString​(String str)` Convert an ObjectId from hex characters.
`void` `setByte​(int index, int value)` Set any byte in the id.
`ObjectId` `toObjectId()` Obtain an immutable copy of this current object name value.

### Methods inherited from class org.eclipse.jgit.lib.AnyObjectId

`abbreviate, compareTo, compareTo, compareTo, copy, copyRawTo, copyRawTo, copyRawTo, copyRawTo, copyTo, copyTo, copyTo, copyTo, copyTo, copyTo, equals, equals, equals, getByte, getFirstByte, getName, hashCode, name, startsWith, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### MutableObjectId

    public MutableObjectId()

Empty constructor. Initialize object with default (zeros) value.

### Method Detail

#### setByte

    public void setByte​(int index,
                        int value)

Set any byte in the id.

Parameters:
  `index` - index of the byte to set in the raw form of the ObjectId. Must be in range [0, `Constants.OBJECT_ID_LENGTH`).
  `value` - the value of the specified byte at `index`. Values are unsigned and thus are in the range [0,255] rather than the signed byte range of [-128, 127].
Throws:
  `ArrayIndexOutOfBoundsException` - `index` is less than 0, equal to `Constants.OBJECT_ID_LENGTH`, or greater than `Constants.OBJECT_ID_LENGTH`.

#### clear

    public void clear()

Make this id match `ObjectId.zeroId()`.

#### fromObjectId

    public void fromObjectId​(AnyObjectId src)

Copy an ObjectId into this mutable buffer.

Parameters:
  `src` - the source id to copy from.

#### fromRaw

    public void fromRaw​(byte[] bs)

Convert an ObjectId from raw binary representation.

Parameters:
  `bs` - the raw byte buffer to read from. At least 20 bytes must be available within this byte array.

#### fromRaw

    public void fromRaw​(byte[] bs,
                        int p)

Convert an ObjectId from raw binary representation.

Parameters:
  `bs` - the raw byte buffer to read from. At least 20 bytes after p must be available within this byte array.
  `p` - position to read the first byte of data from.

#### fromRaw

    public void fromRaw​(int[] ints)

Convert an ObjectId from binary representation expressed in integers.

Parameters:
  `ints` - the raw int buffer to read from. At least 5 integers must be available within this integers array.

#### fromRaw

    public void fromRaw​(int[] ints,
                        int p)

Convert an ObjectId from binary representation expressed in integers.

Parameters:
  `ints` - the raw int buffer to read from. At least 5 integers after p must be available within this integers array.
  `p` - position to read the first integer of data from.

#### fromString

    public void fromString​(byte[] buf,
                           int offset)

Convert an ObjectId from hex characters (US-ASCII).

Parameters:
  `buf` - the US-ASCII buffer to read from. At least 40 bytes after offset must be available within this byte array.
  `offset` - position to read the first character from.

#### fromString

    public void fromString​(String str)

Convert an ObjectId from hex characters.

Parameters:
  `str` - the string to read from. Must be 40 characters long.

#### toObjectId

    public ObjectId toObjectId()

Description copied from class: `AnyObjectId`
Obtain an immutable copy of this current object name value.

See `AnyObjectId.copy()` if `this` is a possibly subclassed (but immutable) identity and the application needs a lightweight identity only reference.

Specified by:
  `toObjectId` in class `AnyObjectId`
Returns:
  an immutable copy. May be `this` if this is already an immutable instance.